<template>
  <div class="content">
    <div
      class="alert alert-danger alert-with-icon"
      data-notify="container"
      v-if="
        auth.user.level != 'guest' &&
          auth.user.level != 'kaprodi' &&
          auth.user.level != 'admin' &&
          auth.user.level != 'superuser'
      "
    >
      <button
        type="button"
        aria-hidden="true"
        @click="onLogout"
        class="close"
        style="padding: 0px 30px 15px 0px"
      >
        <h3>×</h3>
      </button>
      <i data-notify="icon" class="material-icons">add_alert</i>
      <h4 data-notify="message">
        Maaf! sepertinya username atau password yang anda masukkan salah
        <br />
        Mohon login kembali dengan kombinasi username dan password yang benar
      </h4>
    </div>
    <!-- <h1
      v-if="
        auth.user.level != 'kaprodi' &&
          auth.user.level != 'admin' &&
          auth.user.level != 'superuser'
      "
    >
      Maaf! sepertinya username atau password yang anda masukkan salah
    </h1> -->
    <h2
      class="h2"
      style="margin-top: 60px;"
      v-if="
        auth.user.level == 'superuser' ||
          auth.user.level == 'admin' ||
          auth.user.level == 'kaprodi' ||
          auth.user.level == 'guest'
      "
    >
      <!-- <strong>Selamat Datang {{ auth.user.name }}!</strong> -->
      <h3 class="h2">
        <md-icon style="padding-right: 15px;" class="md-size-2x"
          >dashboard</md-icon
        >
        <strong>Dashboard</strong>
      </h3>
    </h2>
    <div v-if="auth.user.level == 'kaprodi'">
      <h2 class="h2" style="margin-top: 60px;">
        <strong>Selamat Datang {{ auth.user.name }}!</strong>
      </h2>
      <p style="margin-top: 35px; font-size: 14px">
        Klik tombol di bawah ini untuk melihat atau menambah mata kuliah KOTA
      </p>
      <div class="main main-raised" style="float:left; top: 70px; height: 0px">
        <a
          href="#/dashboard/report-mata-kuliah-kaprodi"
          class="md-list-item-router md-layout gradient1"
          style=" border-radius: 50px; box-shadow: 5px 5px #c5c5c5"
        >
          <md-button
            class="md-button1 md-simple"
            style="height: 40px; width: 250px;"
          >
            <span
              style="color: white; font-size: 14px; text-transform: capitalize"
            >
              Daftar Mata Kuliah KOTA
            </span>
          </md-button>
        </a>
      </div>
    </div>
    <br />
    <div
      v-if="
        auth.user.level == 'superuser' ||
          auth.user.level == 'admin' ||
          auth.user.level == 'guest'
      "
    >
      <div
        class="main-raised"
        style="border-radius: 10px; margin-top: 10px; margin-bottom: 50px; padding: 20px 20px 20px 20px; background-color: #f2f0f0"
      >
        <md-card-content>
          <p style="text-align:center; font-size: 22px;">
            <strong
              >Grafik Mata Kuliah KOTA Paling Banyak Diminati di Setiap
              Prodi</strong
            >
          </p>
          <p style="text-align:center; font-size: 14px; margin-bottom: 40px">
            Tahun 2015 - Sekarang
          </p>
          <PlanetChart />
        </md-card-content>
      </div>
      <div
        class="main-raised"
        style="border-radius: 10px; margin-top: 100px; margin-bottom: 50px; padding: 20px 20px 20px 20px; background-color: #f2f0f0"
      >
        <div class="md-layout-item">
          <md-card-content>
            <p style="text-align:center; font-size: 22px;">
              <strong
                >Grafik Mata Kuliah KOTA Paling Banyak Diminati di Setiap Rumpun
                Urban</strong
              >
            </p>
            <p style="text-align:center; font-size: 14px; margin-bottom: 30px">
              Tahun 2015 - Sekarang
            </p>
            <PlanetChart2 />
          </md-card-content>
        </div>
      </div>

      <!-- <div
        class="main-raised"
        style="border-radius: 20px; margin-top: 100px; margin-bottom: 50px; padding: 50px 20px 50px 20px; background-color: #f2f0f0"
      > -->
      <!-- <div class="md-layout-item">
          <md-card-content>
            <p style="text-align:center; font-size: 22px;">
              <strong>Tabel Statistik Mata Kuliah KOTA</strong>
            </p>
            <p style="text-align:center; font-size: 14px;">
              Tahun 2015 - Sekarang
            </p>
            <md-table
              v-model="kmeansList.data"
              md-sort="name"
              md-sort-order="asc"
              style="padding: 50px 10px 0px 10px; border-radius: 20px;"
            > -->
      <!-- <md-table-toolbar style="padding-left: 10px">
                <div class="md-toolbar-section-start">
                  <md-field
                    style="padding: 5px 0px 0px 15px; max-width: 300px;"
                  >
                    <label>Pilih Prodi</label>
                    <md-select
                      name="prodi.id"
                      id="prodi"
                      v-model="selectedProdi"
                      @input="searchOnTable"
                      md-dense
                    >
                      <md-option
                        v-for="(prodi, key) in prodiList"
                        :key="key"
                        :value="prodi.id"
                        style="width:100%; left: 10px;"
                      >
                        {{ prodi.singkatan_prodi }} - {{ prodi.nama_prodi }}
                      </md-option>
                    </md-select>
                  </md-field>
                </div>
              </md-table-toolbar> -->

      <!-- <md-table-row slot="md-table-row" slot-scope="{ item }">
                <md-table-cell md-label="Kode" md-sort-by="kode_mk">
                  {{ item.kode_mk }}
                </md-table-cell>
                <md-table-cell md-label="Nama Mata Kuliah" md-sort-by="nama_mk">
                  {{ item.nama_mk }}
                </md-table-cell>
                <md-table-cell md-label="Prodi" md-sort-by="singkatan_prodi">
                  {{ item.singkatan_prodi }}
                </md-table-cell>
                <md-table-cell
                  md-label="Kuota Dibuka"
                  md-sort-by="total_dibuka"
                  style="text-align: center"
                >
                  {{ item.total_dibuka }}
                </md-table-cell>
                <md-table-cell
                  md-label="Mahasiswa Terverifikasi"
                  md-sort-by="total_terisi"
                  style="text-align: center"
                >
                  {{ item.total_terisi }}
                </md-table-cell>
                <md-table-cell md-label="Keterangan" md-sort-by="keterangan">
                  <div
                    v-if="(item.total_terisi / item.total_dibuka) * 100 >= 75"
                  >
                    {{ k3 }}
                  </div>
                  <div
                    v-if="
                      (item.total_terisi / item.total_dibuka) * 100 <= 74 &&
                        (item.total_terisi / item.total_dibuka) * 100 >= 55
                    "
                  >
                    {{ k2 }}
                  </div>
                  <div
                    v-if="(item.total_terisi / item.total_dibuka) * 100 <= 54"
                  >
                    {{ k1 }}
                  </div>
                </md-table-cell>
              </md-table-row>
            </md-table> -->
      <!-- <md-button
              type="submit"
              class="md-login md-success md-lg md-round"
              @click="reportKmeans"
              style="height: 50px; width: 140px"
              ><span
                style="color: white; font-size: 17px; text-transform: capitalize; bottom: 5px"
              >
                Submit
              </span>
            </md-button> -->
      <!-- </md-card-content>
        </div>
      </div> -->
    </div>
  </div>
</template>

<script>
import { mapState, mapActions } from "vuex";
// import { kmeans } from "node-kmeans";
import { PlanetChart, PlanetChart2 } from "@/components";
import { LOGOUT } from "@/services/store/auth.module";

const kmeans = require("node-kmeans");

// const toLower = text => {
//   return text.toString().toLowerCase();
// };

// const searchByProdi = (items, term) => {
//   if (term) {
//     return items.filter(item =>
//       toLower(item.nama_prodi).includes(toLower(term))
//     );
//   }

//   return items;
// };

export default {
  components: { PlanetChart, PlanetChart2 },
  bodyClass: "login-page",
  //   data() {},
  data() {
    return {
      k1: "Kurang Diminati",
      k2: "Cukup Diminati",
      k3: "Banyak Diminati",
      selectedProdi: "",
      search: "",
      searched: [],
      type: ["", "info", "success", "warning", "danger"],
      notifications: {
        topCenter: true
      },
      hasil_kmeans: []
    };
  },
  props: {},
  computed: {
    ...mapState(["auth"]),
    ...mapState("laporan", ["kmeansList", "laporanList", "urbanList"]),
    ...mapState("periode", ["periodeData", "periodeList"]),
    ...mapState("prodi", ["prodiData", "prodiList"]),
    headerStyle() {
      return {
        backgroundImage: `url(${this.image})`
      };
    }
  },
  methods: {
    ...mapActions("laporan", ["getLaporanList", "kmeans"]),
    ...mapActions("periode", ["getPeriode", "getPeriodeList"]),
    ...mapActions("prodi", ["getProdi", "getProdiList"]),
    async onFetchData() {
      await this.getLaporanList();
      await this.kmeans();
      // await this.kmeans({
      //    prodi_id: this.selectedProdi
      // });
      await this.getPeriodeList();
      await this.getProdiList();
      this.reportKmeans();
    },
    onLogin() {
      this.$router.push({ name: "login" });
    },
    onLogout() {
      this.$store
        .dispatch(LOGOUT)
        .then(() => this.$router.push({ name: "login" }));
    },
    reportKmeans() {
      const mapData = this.kmeansList.data.map(value => {
        return [value.total_dibuka, value.total_terisi];
      });

      // console.log(mapData);
      let self = this;
      let selectedCluster;
      // let clusters = [];
      kmeans.clusterize(mapData, { k: 3 }, (err, res) => {
        if (err);
        else {
          // if (err) console.error(err);
          const clusterOne = res[0].centroid.reduce((previous, current) => {
            // console.log(previous);
            // console.log(current);
            return previous + current;
          });

          res[0]["total_centroid"] = clusterOne;

          const clusterTwo = res[1].centroid.reduce((previous, current) => {
            // console.log(previous);
            // console.log(current);
            return previous + current;
          });

          res[1]["total_centroid"] = clusterTwo;

          const clusterThree = res[2].centroid.reduce((previous, current) => {
            // console.log(previous);
            // console.log(current);
            return previous + current;
          });

          res[2]["total_centroid"] = clusterThree;

          const sortArr = res.sort(function(a, b) {
            var keyA = a.total_centroid,
              keyB = b.total_centroid;
            // Compare the 2 dates
            if (keyA < keyB) return -1;
            if (keyA > keyB) return 1;
            return 0;
          });

          let cluster1 = [];

          sortArr[0].clusterInd.forEach(value => {
            data[value].keterangan = this.k1;
            cluster1.push(data[value]);
          });

          // console.log(cluster1);

          let cluster2 = [];

          sortArr[1].clusterInd.forEach(value => {
            data[value].keterangan = this.k2;
            cluster2.push(data[value]);
          });

          // console.log(cluster2);

          let cluster3 = [];

          sortArr[2].clusterInd.forEach(value => {
            data[value].keterangan = this.k3;
            cluster3.push(data[value]);
          });

          // console.log(cluster3);

          let matkulMerge = [...cluster1, ...cluster2, ...cluster3];

          this.hasil_kmeans = matkulMerge;
        }
      });
    },
    searchOnTable() {
      // this.kmeans({
      //   prodi_id: this.selectedProdi
      // });
      // this.searched = searchByProdi(this.kmeansList, this.search);
    },
    onResponsiveInverted() {
      if (window.innerWidth < 600) {
        this.responsive = true;
      } else {
        this.responsive = false;
      }
    }
  },
  async mounted() {
    await this.onFetchData();
    this.onResponsiveInverted();
    window.addEventListener("resize", this.onResponsiveInverted);
    // if (!this.isAuthenticated) {
    //   this.$router.push({ name: "login" });
    // }
  },
  created() {
    this.searched = this.kmeansList;
  }
};
</script>

<style lang="scss" scoped>
.md-app {
  width: 100%;
  height: 100%;
  border: 1px solid rgba(#000, 0.12);
}
.md-drawer {
  width: 300px;
  max-width: calc(100vw - 125px);
  position: fixed;
  overflow: auto;
}
.md-progress-bar {
  position: absolute;
  top: 0;
  right: 0;
  left: 0;
}
</style>

<style lang="css"></style>
